/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1992 Electrotechnical Laboratry (ETL)

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee is hereby granted, provided 
that the above copyright notice and this permission notice 
appear in all copies, and that the name of ETL not be 
used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of an authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY 
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", 
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:	xnntpd.c (eXtentions for NNTP daemon)
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	920921	renamed from XNNTP.c
 V2.0	930822	substituted sscanf() by str_to_argv()
///////////////////////////////////////////////////////////////////////*/

#include <stdio.h>
char *index();

main(ac,av)
	char *av[];
{	char command[1024],*xv[10];
	int xc;

	if(1 < ac)
		xnntp(ac-1,&av[1]);
	else{
		xnntp_startmsg();
		while( gets(command) != NULL ){
			xc = str_to_argv(command,xv);
			if( xc )
				xhist_tolowers(xv[0]);
			if( 0 < xc )
				xnntp(xc,xv);
			flush_socket(fileno(stdout));
		}
	}
	xnntp_logout();
}

#define TERMINATOR(ch)	( ch == '\r' || ch == '\n' || ch == 0 )
#define DELIMITOR(ch)	( ch == ' '  || ch == '\t' )

str_to_argv(str,argv)
	char *str;
	char *argv[];
{	int argc;
	char *sp,ch;

	argc = 0;
	for(sp = str;;){
		for(;; sp++){
			ch = *sp;
			if( TERMINATOR(ch) )
				return argc;
			if( !DELIMITOR(ch) )
				break;
		}
		argv[argc++] = sp;
		for(;; sp++){
			ch = *sp;
			if( TERMINATOR(ch) ){
				*sp++ = 0;
				return argc;
			}
			if( DELIMITOR(ch) ){
				*sp++ = 0;
				break;
			}
		}
	}
}

#include <sys/types.h>
#include <sys/socket.h>
static flush_socket(fd)
{
	send(fd,"",0,MSG_OOB);
}
